#include <stdlib.h>
#include "s_complex.h"
#include "hash.h"

/* In the hash table, "key" is an array of short integer,
   and the data is stored from 1st to (d+1)th entry,
   where d is stored in key[0]. The entry of indicess larger than d+2
   will not be refered.*/



HashCell** init_hashtable()
{
  int i;
  HashCell** ht;

  /* initialize the hash table */
  ht = calloc(sizeof(HashCell*), HASHSIZE);
//  for (i = 0; i < HASHSIZE; i ++) 
//    ht[i] = NULL;

  return ht;
}

int hash_func(key) 
  short key[];
{
  unsigned int value, i;
  
  value = 0;
  for (i = 1; i <= key[0]+1; i ++){
    value = value*31 + key[i];
    }

  return value % HASHSIZE;
}


HashCell* register_hash(ht, key)
  HashCell* ht[];
  short key[];
{
  int hval, i;
  HashCell** cp;

  hval = hash_func(key);
  cp = &(ht[hval]);
  while((*cp) != NULL) {
   cp = &((*cp)->next);
   printf("register in the next cell\n");
   }
  (*cp) = malloc(sizeof(HashCell));
  for (i = 0; i <= key[0]+1; i ++) (*cp)->key[i] = key[i];
  (*cp)->next = NULL;

  return (*cp);
}

HashCell* search_cell(ht, key)
  HashCell* ht[];
  short key[];
{
  int hval, i;
  HashCell** cp;

  hval = hash_func(key);
  cp = &(ht[hval]);
  if ((*cp) == NULL) return NULL;
  while( eq_array((*cp)->key, key) !=1 ) {
    cp = &((*cp)->next);
    if ((*cp) == NULL) return NULL;
    }
  return (*cp);

}

int eq_array(key1, key2)
  short key1[], key2[];
{
  int i;
  for (i = 0; i<=key1[0]+1; i++)
    if (key1[i] != key2[i]) {
      return 0;
      }
  return 1;
}

